/**
 * Copyright(c) 2016 FUJITSU LIMITED All rights reserved.
 */
/*************************************************************
 * include
 *************************************************************/
#include <linux/kernel.h>
#include <linux/string.h>
#include "bmcd_common.h"

/*************************************************************
 * static
 *************************************************************/
static unsigned int data_buf[OSDUMP_DATA_SIZE / 4];

/*************************************************************
 * function
 *************************************************************/
/**
 * @brief bmcd_common_checksum
 * @param SBCRAMデータ
 * @param SBCRAMデータサイズ
 * @retval チェックサム値
 * @note SBCRAMデータからチェックサムの値を取得する
 */
uint32_t bmcd_common_checksum(int *data, unsigned int size)
{
	unsigned int sum;
	unsigned int work;
 	unsigned int csize;
	unsigned int i;

	memset(data_buf, 0, OSDUMP_DATA_SIZE);
	memcpy(data_buf, data, size);

	if ((size % 4) == 0) {
	/* when four multiples */
		csize = size >> 2;
	}
	else {
	/* when not four multiples */
		csize = (size >> 2) + 1;
	}
	sum = 0;
	for (i = 0; i < csize; i++) {
		work = data_buf[i];
		sum = sum + work;
	}
	sum = sum + 0xaaaaaaaa;

	return (sum);
}

