#ifndef __BMCD_STATE__
#define __BMCD_STATE__

typedef enum {
	BMCD_CMD_SYSSTS_REPORT	= 0,	/* System Status Report (NetFn:38h CMD:01h) */
	BMCD_CMD_SHUTDOWN_REASON,	/* Get Shutdown Reason (NetFn:38h CMD:02h */
	BMCD_CMD_SET_ERRLOG,		/* Set Node OS Error Log (NetFn:38h CMD:31h) */
	BMCD_CMD_DUMP_UPLOAD_READY,	/* Dump Upload Ready Notice (NetFn:38h CMD:40h) */
	BMCD_CMD_DUMP_UPLOAD_START,	/* Dump Upload Start (NetFn:38h CMD:41h) */
	BMCD_CMD_DUMP_UPLOAD_END,	/* Dump Upload End (NetFN:38h CMD:43h) */
	BMCD_CMD_IPMI_NUM,
} bmcd_cmd_t;

typedef enum {
	BMCD_STATE_UNLOAD = 0,
	BMCD_STATE_STANDBY,
	BMCD_STATE_PROCESSING,
	BMCD_STATE_KILL
} bmcd_state_t;

struct bmcd_queue_request {
	bmcd_cmd_t command;			/* IPMIコマンドコード */
	void *param;				/* IPMIコマンドパラメータ */
	uint32_t param_size;			/* IPMIコマンドパラメータサイズ */
	void *sram;				/* SRAMデータ */
	uint32_t sram_size;			/* SRAMデータサイズ */
	void (*async_func)(short);		/* 非同期時にのみ設定するコールバック関数 */
	void (*sync_func)(short, void *);	/* 同期時にのみ設定するコールバック関数 */
	void *private;				/* 同期時にコールバック関数の第二引数に設定するデータ */
};

extern int bmcd_queue_init(void);
extern void bmcd_queue_exit(void);
extern int bmcd_queue_entry(struct bmcd_queue_request *);
extern void bmcd_queue_kill_end(void);

#endif /* __BMCD_STATE__ */
